#!/bin/bash
PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
LOG_FILE="/var/log/esia/watchdog.log"
mkdir -p "/var/log/esia"

SCRIPTNAME="esia-watchdog"

function send_log {
        TYPE=$1
        MESSAGE=$2
        DATE=$(date +"%b %d %H:%M:%S")
        HOST=$(hostname)
 
        printf "$DATE $HOST $SCRIPTNAME : %*s - $MESSAGE\n" 7 $TYPE >> $LOG_FILE
}

LINE=$(grep "CHECKED" $LOG_FILE|tail -n 1)
TIME=$(echo $LINE |cut -d" " -f3)
last_test=$(date -d"$TIME" "+%s")

LINE2=$(grep "watchdog started" $LOG_FILE|tail -n 1)
TIME=$(echo $LINE |cut -d" " -f3)
last_start=$(date -d"$TIME" "+%s")

for elm in $(echo $LINE)
do
        echo $elm|grep "NEXT" > /dev/null
        if [ $? -eq 0 ]
        then
                next_test=$(echo $elm|cut -d":" -f2)
        fi

        echo $elm|grep "CHECKED" > /dev/null
        if [ $? -eq 0 ]
        then
                checked_nb=$(echo $elm|cut -d":" -f2)
        fi
done 

current_time=$(date +"%s")

#On prends la date la plus récente
if [ $last_start -lt $last_test ]
then
        last=$last_test
else
        last=$last_start
fi

(( diff_time = current_time - last ))
(( diff_tolerate = next_test * 2 ))

message="Watchdog running"
service watchdog status >/dev/null
if [ $? -ne 0 ]
then
        service watchdog start && service watchdog status > /dev/null
        if [ $? -ne 0 ]
        then
                message="$message:NO"
                send_log "CRON" "$message"
                exit 1
        fi
        message="$message:STARTED"
else
        message="$message:YES"

        message="$message Last exec $diff_time s < $diff_tolerate s tolerate ($next_test x 2):"
        if [ $diff_time -gt $diff_tolerate ]
        then
                service watchdog restart && service watchdog status > /dev/null
                if [ $? -ne 0 ]
                then
                        message="$message:NO Restarted:NO"
                        send_log "CRON" "$message"
                        exit 1
                fi
                message="$message:NO Restarted:YES"
        else
                message="$message:YES"
        fi
fi

send_log "CRON" "$message"

exit 0
